function D = ML(train_features, train_targets, AlgorithmParameters, region)

% Classify using the maximum-likelyhood algorithm
% Inputs:
% 	features	- Train features
%	targets	- Train targets
%	Dummy		- Unused
%	region	- Decision region vector: [-x x -y y number_of_points]
%
% Outputs
%	D			- Decision sufrace

train_one  = find(train_targets == 1);
train_zero = find(train_targets == 0);

%Estimate mean and covariance for class 0
m0 = mean(train_features(:,train_zero)');
s0 = cov(train_features(:,train_zero)');
P0 = length(train_zero)/length(train_targets);

%Estimate mean and covariance for class 1
m1 = mean(train_features(:,train_one)');
s1 = cov(train_features(:,train_one)');
P1 = length(train_one)/length(train_targets);

%Find decision region
D		= decision_region(m0, s0, 1, m1, s1, 1, region);
