% ---------------------------------------------------------------- 
% FUNCTION   normalize
% ---------------------------------------------------------------- 
%		normalizes the rows of a matrix
% Usage: 
%	        outmat = normalize(inmat)
% Input:
%		inmat = column vector of row vectors
% Output:
%
% __________________________
%  Author: Vittorio Castelli
%  Copyright IBM T. J. Watson Research Center
%      January 27, 1995;	Last modified: January 27, 1995

function outmat = normalize(inmat);

[M,N] = size(inmat);
aaa = ones(1,N);
outmat = inmat.^2;
tempmat = sqrt(sum(outmat'));
tempmat = tempmat';
tempmat = tempmat.^(-1);
tempmat = tempmat*aaa;
outmat = inmat.*tempmat;

